Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_O : connectives.equal (nat -> nat) (plus_body O) (fun (m:nat) => m).
Definition eq_plus_body_O : leibniz.leibniz (nat -> nat) (plus_body O) (fun (m:nat) => m) := ((((connectives.equal_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (axiom_plus_body_O).
Definition sym_eq_plus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => m) (plus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (eq_plus_body_O).
Axiom axiom_plus_body_S : forall (n:nat), connectives.equal (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)).
Definition eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((axiom_plus_body_S) (n)).
Definition sym_eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => S (plus n m)) (plus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((eq_plus_body_S) (n)).
Definition plus_n_Sm : forall (n:nat), forall (m:nat), logic.eq (nat) (S (plus n m)) (plus n (S m)) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), logic.eq (nat) (S (plus _x_365 m)) (plus _x_365 (S m)))) (fun (m:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus O (S m)))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S m) (y (S m)))) (((logic.refl) (nat)) (S m))))))))) (fun (x_366:nat) => fun (_x_368:forall (m:nat), logic.eq (nat) (S (plus x_366 m)) (plus x_366 (S m))) => (fun (m:nat) => (((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus (S x_366) (S m)))) ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (S (plus x_366 m))) (y (S m)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S m))) (fun (__:nat) => logic.eq (nat) (S __) (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) __ (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) (plus x_366 (S (S m))) __)) (((logic.refl) (nat)) (plus x_366 (S (S m))))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 m))) ((_x_368) (m))))))))))) (n).
